<center><a href="ex6.c">Actual source code: ex6.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:32:27+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a><font color="#B22222">/* Program usage:  ex3 [-help] [all PETSc options] */</font>

<a name="line4">  4: </a>static char help[] =<font color="#666666">"Solves a simple time-dependent linear PDE (the heat equation).\n\</font>
<a name="line5">  5: </a><font color="#666666">Input parameters include:\n\</font>
<a name="line6">  6: </a><font color="#666666">  -m &lt;points&gt;, where &lt;points&gt; = number of grid points\n\</font>
<a name="line7">  7: </a><font color="#666666">  -time_dependent_rhs : Treat the problem as having a time-dependent right-hand side\n\</font>
<a name="line8">  8: </a><font color="#666666">  -debug              : Activate debugging printouts\n\</font>
<a name="line9">  9: </a><font color="#666666">  -nox                : Deactivate x-window graphics\n\n"</font>;

<a name="line11"> 11: </a><font color="#B22222">/*</font>
<a name="line12"> 12: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>^time-dependent linear problems</font>
<a name="line13"> 13: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>^heat equation</font>
<a name="line14"> 14: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>^diffusion equation</font>
<a name="line15"> 15: </a><font color="#B22222">   Routines: <A href="../../../../docs/manualpages/TS/TSCreate.html#TSCreate">TSCreate</A>(); <A href="../../../../docs/manualpages/TS/TSSetSolution.html#TSSetSolution">TSSetSolution</A>(); <A href="../../../../docs/manualpages/TS/TSSetRHSMatrix.html#TSSetRHSMatrix">TSSetRHSMatrix</A>();</font>
<a name="line16"> 16: </a><font color="#B22222">   Routines: <A href="../../../../docs/manualpages/TS/TSSetInitialTimeStep.html#TSSetInitialTimeStep">TSSetInitialTimeStep</A>(); <A href="../../../../docs/manualpages/TS/TSSetDuration.html#TSSetDuration">TSSetDuration</A>(); <A href="../../../../docs/manualpages/TS/TSSetMonitor.html#TSSetMonitor">TSSetMonitor</A>();</font>
<a name="line17"> 17: </a><font color="#B22222">   Routines: <A href="../../../../docs/manualpages/TS/TSSetFromOptions.html#TSSetFromOptions">TSSetFromOptions</A>(); <A href="../../../../docs/manualpages/TS/TSStep.html#TSStep">TSStep</A>(); <A href="../../../../docs/manualpages/TS/TSDestroy.html#TSDestroy">TSDestroy</A>(); </font>
<a name="line18"> 18: </a><font color="#B22222">   Routines: <A href="../../../../docs/manualpages/TS/TSSetTimeStep.html#TSSetTimeStep">TSSetTimeStep</A>(); <A href="../../../../docs/manualpages/TS/TSGetTimeStep.html#TSGetTimeStep">TSGetTimeStep</A>();</font>
<a name="line19"> 19: </a><font color="#B22222">   Processors: 1</font>
<a name="line20"> 20: </a><font color="#B22222">*/</font>

<a name="line22"> 22: </a><font color="#B22222">/* ------------------------------------------------------------------------</font>

<a name="line24"> 24: </a><font color="#B22222">   This program solves the one-dimensional heat equation (also called the</font>
<a name="line25"> 25: </a><font color="#B22222">   diffusion equation),</font>
<a name="line26"> 26: </a><font color="#B22222">       u_t = u_xx, </font>
<a name="line27"> 27: </a><font color="#B22222">   on the domain 0 &lt;= x &lt;= 1, with the boundary conditions</font>
<a name="line28"> 28: </a><font color="#B22222">       u(t,0) = 0, u(t,1) = 0,</font>
<a name="line29"> 29: </a><font color="#B22222">   and the initial condition</font>
<a name="line30"> 30: </a><font color="#B22222">       u(0,x) = sin(6*pi*x) + 3*sin(2*pi*x).</font>
<a name="line31"> 31: </a><font color="#B22222">   This is a linear, second-order, parabolic equation.</font>

<a name="line33"> 33: </a><font color="#B22222">   We discretize the right-hand side using finite differences with</font>
<a name="line34"> 34: </a><font color="#B22222">   uniform grid spacing h:</font>
<a name="line35"> 35: </a><font color="#B22222">       u_xx = (u_{i+1} - 2u_{i} + u_{i-1})/(h^2)</font>
<a name="line36"> 36: </a><font color="#B22222">   We then demonstrate time evolution using the various <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> methods by</font>
<a name="line37"> 37: </a><font color="#B22222">   running the program via</font>
<a name="line38"> 38: </a><font color="#B22222">       ex3 -ts_type &lt;timestepping solver&gt;</font>

<a name="line40"> 40: </a><font color="#B22222">   We compare the approximate solution with the exact solution, given by</font>
<a name="line41"> 41: </a><font color="#B22222">       u_exact(x,t) = exp(-36*pi*pi*t) * sin(6*pi*x) +</font>
<a name="line42"> 42: </a><font color="#B22222">                      3*exp(-4*pi*pi*t) * sin(2*pi*x)</font>

<a name="line44"> 44: </a><font color="#B22222">   Notes:</font>
<a name="line45"> 45: </a><font color="#B22222">   This code demonstrates the <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> solver interface to two variants of </font>
<a name="line46"> 46: </a><font color="#B22222">   linear problems, u_t = f(u,t), namely</font>
<a name="line47"> 47: </a><font color="#B22222">     - time-dependent f:   f(u,t) is a function of t</font>
<a name="line48"> 48: </a><font color="#B22222">     - time-independent f: f(u,t) is simply f(u)</font>

<a name="line50"> 50: </a><font color="#B22222">    The parallel version of this code is ts/examples/tutorials/ex4.c</font>

<a name="line52"> 52: </a><font color="#B22222">  ------------------------------------------------------------------------- */</font>

<a name="line54"> 54: </a><font color="#B22222">/* </font>
<a name="line55"> 55: </a><font color="#B22222">   Include "ts.h" so that we can use <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> solvers.  Note that this file</font>
<a name="line56"> 56: </a><font color="#B22222">   automatically includes:</font>
<a name="line57"> 57: </a><font color="#B22222">     petsc.h  - base PETSc routines   vec.h  - vectors</font>
<a name="line58"> 58: </a><font color="#B22222">     sys.h    - system routines       mat.h  - matrices</font>
<a name="line59"> 59: </a><font color="#B22222">     is.h     - index sets            ksp.h  - Krylov subspace methods</font>
<a name="line60"> 60: </a><font color="#B22222">     viewer.h - viewers               pc.h   - preconditioners</font>
<a name="line61"> 61: </a><font color="#B22222">     snes.h - nonlinear solvers</font>
<a name="line62"> 62: </a><font color="#B22222">*/</font>

<a name="line64"> 64: </a> #include <A href="../../../../include/petscts.h.html">petscts.h</A>

<a name="line66"> 66: </a><font color="#B22222">/* </font>
<a name="line67"> 67: </a><font color="#B22222">   User-defined application context - contains data needed by the </font>
<a name="line68"> 68: </a><font color="#B22222">   application-provided call-back routines.</font>
<a name="line69"> 69: </a><font color="#B22222">*/</font>
<a name="line70"> 70: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line71"> 71: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>         solution;          <font color="#B22222">/* global exact solution vector */</font>
<a name="line72"> 72: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>    m;                 <font color="#B22222">/* total number of grid points */</font>
<a name="line73"> 73: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>   h;                 <font color="#B22222">/* mesh width h = 1/(m-1) */</font>
<a name="line74"> 74: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>  debug;             <font color="#B22222">/* flag (1 indicates activation of debugging printouts) */</font>
<a name="line75"> 75: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer1, viewer2;  <font color="#B22222">/* viewers for the solution and error */</font>
<a name="line76"> 76: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>   norm_2, norm_max;  <font color="#B22222">/* error norms */</font>
<a name="line77"> 77: </a>} AppCtx;

<a name="line79"> 79: </a><font color="#B22222">/* </font>
<a name="line80"> 80: </a><font color="#B22222">   User-defined routines</font>
<a name="line81"> 81: </a><font color="#B22222">*/</font>

<a name="line90"> 90: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line91"> 91: </a>{
<a name="line92"> 92: </a>  AppCtx         appctx;                 <font color="#B22222">/* user-defined application context */</font>
<a name="line93"> 93: </a>  <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A>             ts;                     <font color="#B22222">/* timestepping context */</font>
<a name="line94"> 94: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            A;                      <font color="#B22222">/* matrix data structure */</font>
<a name="line95"> 95: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            u;                      <font color="#B22222">/* approximate solution vector */</font>
<a name="line96"> 96: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      time_total_max = 100.0; <font color="#B22222">/* default max total time */</font>
<a name="line97"> 97: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       time_steps_max = 100;   <font color="#B22222">/* default max timesteps */</font>
<a name="line98"> 98: </a>  <A href="../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A>      draw;                   <font color="#B22222">/* drawing context */</font>
<a name="line100">100: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       steps, m;
<a name="line101">101: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line102">102: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      dt;
<a name="line103">103: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      ftime;
<a name="line104">104: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;
<a name="line105">105: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line106">106: </a><font color="#B22222">     Initialize program and set problem parameters</font>
<a name="line107">107: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line108">108: </a>
<a name="line109">109: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char*)0,help);
<a name="line110">110: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line111">111: </a>  <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/size.html#size">size</A> != 1) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"This is a uniprocessor example only!"</font>);

<a name="line113">113: </a>  m    = 60;
<a name="line114">114: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-m"</font>,&amp;m,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line115">115: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-debug"</font>,&amp;appctx.debug);
<a name="line116">116: </a>  appctx.m        = m;
<a name="line117">117: </a>  appctx.h        = 1.0/(m-1.0);
<a name="line118">118: </a>  appctx.norm_2   = 0.0;
<a name="line119">119: </a>  appctx.norm_max = 0.0;
<a name="line120">120: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"Solving a linear <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> problem on 1 processor\n"</font>);

<a name="line122">122: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-time_steps_max"</font>,&amp;time_steps_max,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line124">124: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line125">125: </a><font color="#B22222">     Create vector data structures</font>
<a name="line126">126: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line128">128: </a>  <font color="#B22222">/* </font>
<a name="line129">129: </a><font color="#B22222">     Create vector data structures for approximate and exact solutions</font>
<a name="line130">130: </a><font color="#B22222">  */</font>
<a name="line131">131: </a>  <A href="../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,m,&amp;u);
<a name="line132">132: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(u,&amp;appctx.solution);

<a name="line134">134: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line135">135: </a><font color="#B22222">     Set up displays to show graphs of the solution and error </font>
<a name="line136">136: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line138">138: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,0,<font color="#666666">""</font>,80,380,400,160,&amp;appctx.viewer1);
<a name="line139">139: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>(appctx.viewer1,0,&amp;draw);
<a name="line140">140: </a>  <A href="../../../../docs/manualpages/Draw/PetscDrawSetDoubleBuffer.html#PetscDrawSetDoubleBuffer">PetscDrawSetDoubleBuffer</A>(draw);
<a name="line141">141: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,0,<font color="#666666">""</font>,80,0,400,160,&amp;appctx.viewer2);
<a name="line142">142: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>(appctx.viewer2,0,&amp;draw);
<a name="line143">143: </a>  <A href="../../../../docs/manualpages/Draw/PetscDrawSetDoubleBuffer.html#PetscDrawSetDoubleBuffer">PetscDrawSetDoubleBuffer</A>(draw);

<a name="line145">145: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line146">146: </a><font color="#B22222">     Create timestepping solver context</font>
<a name="line147">147: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line149">149: </a>  <A href="../../../../docs/manualpages/TS/TSCreate.html#TSCreate">TSCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,&amp;ts);
<a name="line150">150: </a>  <A href="../../../../docs/manualpages/TS/TSSetProblemType.html#TSSetProblemType">TSSetProblemType</A>(ts,TS_LINEAR);

<a name="line152">152: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line153">153: </a><font color="#B22222">     Set optional user-defined monitoring routine</font>
<a name="line154">154: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line156">156: </a>  <A href="../../../../docs/manualpages/TS/TSSetMonitor.html#TSSetMonitor">TSSetMonitor</A>(ts,Monitor,&amp;appctx,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line158">158: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>

<a name="line160">160: </a><font color="#B22222">     Create matrix data structure; set matrix evaluation routine.</font>
<a name="line161">161: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line163">163: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,&amp;A);
<a name="line164">164: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(A,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,m,m);
<a name="line165">165: </a>  <A href="../../../../docs/manualpages/Mat/MatSetFromOptions.html#MatSetFromOptions">MatSetFromOptions</A>(A);

<a name="line167">167: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-time_dependent_rhs"</font>,&amp;flg);
<a name="line168">168: </a>  <font color="#4169E1">if</font> (flg) {
<a name="line169">169: </a>    <font color="#B22222">/*</font>
<a name="line170">170: </a><font color="#B22222">       For linear problems with a time-dependent f(u,t) in the equation </font>
<a name="line171">171: </a><font color="#B22222">       u_t = f(u,t), the user provides the discretized right-hand-side</font>
<a name="line172">172: </a><font color="#B22222">       as a time-dependent matrix.</font>
<a name="line173">173: </a><font color="#B22222">    */</font>
<a name="line174">174: </a>    <A href="../../../../docs/manualpages/TS/TSSetRHSMatrix.html#TSSetRHSMatrix">TSSetRHSMatrix</A>(ts,A,A,RHSMatrixHeat,&amp;appctx);
<a name="line175">175: </a>  } <font color="#4169E1">else</font> {
<a name="line176">176: </a>    <font color="#B22222">/*</font>
<a name="line177">177: </a><font color="#B22222">       For linear problems with a time-independent f(u) in the equation </font>
<a name="line178">178: </a><font color="#B22222">       u_t = f(u), the user provides the discretized right-hand-side</font>
<a name="line179">179: </a><font color="#B22222">       as a matrix only once, and then sets a null matrix evaluation</font>
<a name="line180">180: </a><font color="#B22222">       routine.</font>
<a name="line181">181: </a><font color="#B22222">    */</font>
<a name="line182">182: </a>    <A href="../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A> A_structure;
<a name="line183">183: </a>    RHSMatrixHeat(ts,0.0,&amp;A,&amp;A,&amp;A_structure,&amp;appctx);
<a name="line184">184: </a>    <A href="../../../../docs/manualpages/TS/TSSetRHSMatrix.html#TSSetRHSMatrix">TSSetRHSMatrix</A>(ts,A,A,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;appctx);
<a name="line185">185: </a>  }

<a name="line187">187: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line188">188: </a><font color="#B22222">     Set solution vector and initial timestep</font>
<a name="line189">189: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line191">191: </a>  dt = appctx.h*appctx.h/2.0;
<a name="line192">192: </a>  <A href="../../../../docs/manualpages/TS/TSSetInitialTimeStep.html#TSSetInitialTimeStep">TSSetInitialTimeStep</A>(ts,0.0,dt);
<a name="line193">193: </a>  <A href="../../../../docs/manualpages/TS/TSSetSolution.html#TSSetSolution">TSSetSolution</A>(ts,u);

<a name="line195">195: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line196">196: </a><font color="#B22222">     Customize timestepping solver:  </font>
<a name="line197">197: </a><font color="#B22222">       - Set the solution method to be the Backward Euler method.</font>
<a name="line198">198: </a><font color="#B22222">       - Set timestepping duration info </font>
<a name="line199">199: </a><font color="#B22222">     Then set runtime options, which can override these defaults.</font>
<a name="line200">200: </a><font color="#B22222">     For example,</font>
<a name="line201">201: </a><font color="#B22222">          -ts_max_steps &lt;maxsteps&gt; -ts_max_time &lt;maxtime&gt;</font>
<a name="line202">202: </a><font color="#B22222">     to override the defaults set by <A href="../../../../docs/manualpages/TS/TSSetDuration.html#TSSetDuration">TSSetDuration</A>().</font>
<a name="line203">203: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line205">205: </a>  <A href="../../../../docs/manualpages/TS/TSSetDuration.html#TSSetDuration">TSSetDuration</A>(ts,time_steps_max,time_total_max);
<a name="line206">206: </a>  <A href="../../../../docs/manualpages/TS/TSSetFromOptions.html#TSSetFromOptions">TSSetFromOptions</A>(ts);

<a name="line208">208: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line209">209: </a><font color="#B22222">     Solve the problem</font>
<a name="line210">210: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line212">212: </a>  <font color="#B22222">/*</font>
<a name="line213">213: </a><font color="#B22222">     Evaluate initial conditions</font>
<a name="line214">214: </a><font color="#B22222">  */</font>
<a name="line215">215: </a>  InitialConditions(u,&amp;appctx);

<a name="line217">217: </a>  <font color="#B22222">/*</font>
<a name="line218">218: </a><font color="#B22222">     Run the timestepping solver</font>
<a name="line219">219: </a><font color="#B22222">  */</font>
<a name="line220">220: </a>  <A href="../../../../docs/manualpages/TS/TSStep.html#TSStep">TSStep</A>(ts,&amp;steps,&amp;ftime);

<a name="line222">222: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line223">223: </a><font color="#B22222">     View timestepping solver info</font>
<a name="line224">224: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line226">226: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"avg. error (2 norm) = %G, avg. error (max norm) = %G\n"</font>,
<a name="line227">227: </a>              appctx.norm_2/steps,appctx.norm_max/steps);
<a name="line228">228: </a>  <A href="../../../../docs/manualpages/TS/TSView.html#TSView">TSView</A>(ts,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);

<a name="line230">230: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line231">231: </a><font color="#B22222">     Free work space.  All PETSc objects should be destroyed when they</font>
<a name="line232">232: </a><font color="#B22222">     are no longer needed.</font>
<a name="line233">233: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line235">235: </a>  <A href="../../../../docs/manualpages/TS/TSDestroy.html#TSDestroy">TSDestroy</A>(ts);
<a name="line236">236: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);
<a name="line237">237: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(u);
<a name="line238">238: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(appctx.viewer1);
<a name="line239">239: </a>  <A href="../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(appctx.viewer2);
<a name="line240">240: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(appctx.solution);

<a name="line242">242: </a>  <font color="#B22222">/*</font>
<a name="line243">243: </a><font color="#B22222">     Always call <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>() before exiting a program.  This routine</font>
<a name="line244">244: </a><font color="#B22222">       - finalizes the PETSc libraries as well as MPI</font>
<a name="line245">245: </a><font color="#B22222">       - provides summary and diagnostic information if certain runtime</font>
<a name="line246">246: </a><font color="#B22222">         options are chosen (e.g., -log_summary). </font>
<a name="line247">247: </a><font color="#B22222">  */</font>
<a name="line248">248: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line249">249: </a>  <font color="#4169E1">return</font> 0;
<a name="line250">250: </a>}
<a name="line251">251: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line254">254: </a><font color="#B22222">/*</font>
<a name="line255">255: </a><font color="#B22222">   InitialConditions - Computes the solution at the initial time. </font>

<a name="line257">257: </a><font color="#B22222">   Input Parameter:</font>
<a name="line258">258: </a><font color="#B22222">   u - uninitialized solution vector (global)</font>
<a name="line259">259: </a><font color="#B22222">   appctx - user-defined application context</font>

<a name="line261">261: </a><font color="#B22222">   Output Parameter:</font>
<a name="line262">262: </a><font color="#B22222">   u - vector with solution at initial time (global)</font>
<a name="line263">263: </a><font color="#B22222">*/</font>
<a name="line264">264: </a><strong><font color="#4169E1"><a name="InitialConditions"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> InitialConditions(<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> u,AppCtx *appctx)</font></strong>
<a name="line265">265: </a>{
<a name="line266">266: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *u_localptr;
<a name="line267">267: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i;

<a name="line270">270: </a>  <font color="#B22222">/* </font>
<a name="line271">271: </a><font color="#B22222">    Get a pointer to vector data.</font>
<a name="line272">272: </a><font color="#B22222">    - For default PETSc vectors, <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>() returns a pointer to</font>
<a name="line273">273: </a><font color="#B22222">      the data array.  Otherwise, the routine is implementation dependent.</font>
<a name="line274">274: </a><font color="#B22222">    - You MUST call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>() when you no longer need access to</font>
<a name="line275">275: </a><font color="#B22222">      the array.</font>
<a name="line276">276: </a><font color="#B22222">    - Note that the Fortran interface to <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>() differs from the</font>
<a name="line277">277: </a><font color="#B22222">      C version.  See the users manual for details.</font>
<a name="line278">278: </a><font color="#B22222">  */</font>
<a name="line279">279: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(u,&amp;u_localptr);

<a name="line281">281: </a>  <font color="#B22222">/* </font>
<a name="line282">282: </a><font color="#B22222">     We initialize the solution array by simply writing the solution</font>
<a name="line283">283: </a><font color="#B22222">     directly into the array locations.  Alternatively, we could use</font>
<a name="line284">284: </a><font color="#B22222">     <A href="../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>() or <A href="../../../../docs/manualpages/Vec/VecSetValuesLocal.html#VecSetValuesLocal">VecSetValuesLocal</A>().</font>
<a name="line285">285: </a><font color="#B22222">  */</font>
<a name="line286">286: </a>  <font color="#4169E1">for</font> (i=0; i&lt;appctx-&gt;m; i++) {
<a name="line287">287: </a>    u_localptr[i] = sin(PETSC_PI*i*6.*appctx-&gt;h) + 3.*sin(PETSC_PI*i*2.*appctx-&gt;h);
<a name="line288">288: </a>  }

<a name="line290">290: </a>  <font color="#B22222">/* </font>
<a name="line291">291: </a><font color="#B22222">     Restore vector</font>
<a name="line292">292: </a><font color="#B22222">  */</font>
<a name="line293">293: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(u,&amp;u_localptr);

<a name="line295">295: </a>  <font color="#B22222">/* </font>
<a name="line296">296: </a><font color="#B22222">     Print debugging information if desired</font>
<a name="line297">297: </a><font color="#B22222">  */</font>
<a name="line298">298: </a>  <font color="#4169E1">if</font> (appctx-&gt;debug) {
<a name="line299">299: </a>     printf(<font color="#666666">"initial guess vector\n"</font>);
<a name="line300">300: </a>     <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(u,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);
<a name="line301">301: </a>  }

<a name="line303">303: </a>  <font color="#4169E1">return</font> 0;
<a name="line304">304: </a>}
<a name="line305">305: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line308">308: </a><font color="#B22222">/*</font>
<a name="line309">309: </a><font color="#B22222">   ExactSolution - Computes the exact solution at a given time.</font>

<a name="line311">311: </a><font color="#B22222">   Input Parameters:</font>
<a name="line312">312: </a><font color="#B22222">   t - current time</font>
<a name="line313">313: </a><font color="#B22222">   solution - vector in which exact solution will be computed</font>
<a name="line314">314: </a><font color="#B22222">   appctx - user-defined application context</font>

<a name="line316">316: </a><font color="#B22222">   Output Parameter:</font>
<a name="line317">317: </a><font color="#B22222">   solution - vector with the newly computed exact solution</font>
<a name="line318">318: </a><font color="#B22222">*/</font>
<a name="line319">319: </a><strong><font color="#4169E1"><a name="ExactSolution"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ExactSolution(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> solution,AppCtx *appctx)</font></strong>
<a name="line320">320: </a>{
<a name="line321">321: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *s_localptr, h = appctx-&gt;h, ex1, ex2, sc1, sc2;
<a name="line322">322: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i;

<a name="line325">325: </a>  <font color="#B22222">/*</font>
<a name="line326">326: </a><font color="#B22222">     Get a pointer to vector data.</font>
<a name="line327">327: </a><font color="#B22222">  */</font>
<a name="line328">328: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(solution,&amp;s_localptr);

<a name="line330">330: </a>  <font color="#B22222">/* </font>
<a name="line331">331: </a><font color="#B22222">     Simply write the solution directly into the array locations.</font>
<a name="line332">332: </a><font color="#B22222">     Alternatively, we culd use <A href="../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>() or <A href="../../../../docs/manualpages/Vec/VecSetValuesLocal.html#VecSetValuesLocal">VecSetValuesLocal</A>().</font>
<a name="line333">333: </a><font color="#B22222">  */</font>
<a name="line334">334: </a>  ex1 = exp(-36.*PETSC_PI*PETSC_PI*t); ex2 = exp(-4.*PETSC_PI*PETSC_PI*t);
<a name="line335">335: </a>  sc1 = PETSC_PI*6.*h;                 sc2 = PETSC_PI*2.*h;
<a name="line336">336: </a>  <font color="#4169E1">for</font> (i=0; i&lt;appctx-&gt;m; i++) {
<a name="line337">337: </a>    s_localptr[i] = sin(PetscRealPart(sc1)*(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)i)*ex1 + 3.*sin(PetscRealPart(sc2)*(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)i)*ex2;
<a name="line338">338: </a>  }

<a name="line340">340: </a>  <font color="#B22222">/* </font>
<a name="line341">341: </a><font color="#B22222">     Restore vector</font>
<a name="line342">342: </a><font color="#B22222">  */</font>
<a name="line343">343: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(solution,&amp;s_localptr);
<a name="line344">344: </a>  <font color="#4169E1">return</font> 0;
<a name="line345">345: </a>}
<a name="line346">346: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line349">349: </a><font color="#B22222">/*</font>
<a name="line350">350: </a><font color="#B22222">   Monitor - User-provided routine to monitor the solution computed at </font>
<a name="line351">351: </a><font color="#B22222">   each timestep.  This example plots the solution and computes the</font>
<a name="line352">352: </a><font color="#B22222">   error in two different norms.</font>

<a name="line354">354: </a><font color="#B22222">   This example also demonstrates changing the timestep via <A href="../../../../docs/manualpages/TS/TSSetTimeStep.html#TSSetTimeStep">TSSetTimeStep</A>().</font>

<a name="line356">356: </a><font color="#B22222">   Input Parameters:</font>
<a name="line357">357: </a><font color="#B22222">   ts     - the timestep context</font>
<a name="line358">358: </a><font color="#B22222">   step   - the count of the current step (with 0 meaning the</font>
<a name="line359">359: </a><font color="#B22222">             initial condition)</font>
<a name="line360">360: </a><font color="#B22222">   crtime  - the current time</font>
<a name="line361">361: </a><font color="#B22222">   u      - the solution at this timestep</font>
<a name="line362">362: </a><font color="#B22222">   ctx    - the user-provided context for this monitoring routine.</font>
<a name="line363">363: </a><font color="#B22222">            In this case we use the application context which contains </font>
<a name="line364">364: </a><font color="#B22222">            information about the problem <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>, workspace and the exact </font>
<a name="line365">365: </a><font color="#B22222">            solution.</font>
<a name="line366">366: </a><font color="#B22222">*/</font>
<a name="line367">367: </a><strong><font color="#4169E1"><a name="Monitor"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> Monitor(<A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> step,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> crtime,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> u,void *ctx)</font></strong>
<a name="line368">368: </a>{
<a name="line369">369: </a>  AppCtx         *appctx = (AppCtx*) ctx;   <font color="#B22222">/* user-defined application context */</font>
<a name="line371">371: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      norm_2, norm_max, dt, dttol;
<a name="line372">372: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flg;

<a name="line374">374: </a>  <font color="#B22222">/* </font>
<a name="line375">375: </a><font color="#B22222">     View a graph of the current iterate</font>
<a name="line376">376: </a><font color="#B22222">  */</font>
<a name="line377">377: </a>  <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(u,appctx-&gt;viewer2);

<a name="line379">379: </a>  <font color="#B22222">/* </font>
<a name="line380">380: </a><font color="#B22222">     Compute the exact solution</font>
<a name="line381">381: </a><font color="#B22222">  */</font>
<a name="line382">382: </a>  ExactSolution(crtime,appctx-&gt;solution,appctx);

<a name="line384">384: </a>  <font color="#B22222">/*</font>
<a name="line385">385: </a><font color="#B22222">     Print debugging information if desired</font>
<a name="line386">386: </a><font color="#B22222">  */</font>
<a name="line387">387: </a>  <font color="#4169E1">if</font> (appctx-&gt;debug) {
<a name="line388">388: </a>     printf(<font color="#666666">"Computed solution vector\n"</font>);
<a name="line389">389: </a>     <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(u,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);
<a name="line390">390: </a>     printf(<font color="#666666">"Exact solution vector\n"</font>);
<a name="line391">391: </a>     <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(appctx-&gt;solution,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);
<a name="line392">392: </a>  }

<a name="line394">394: </a>  <font color="#B22222">/*</font>
<a name="line395">395: </a><font color="#B22222">     Compute the 2-norm and max-norm of the error</font>
<a name="line396">396: </a><font color="#B22222">  */</font>
<a name="line397">397: </a>  <A href="../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(appctx-&gt;solution,-1.0,u);
<a name="line398">398: </a>  <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(appctx-&gt;solution,<A href="../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,&amp;norm_2);
<a name="line399">399: </a>  norm_2 = sqrt(appctx-&gt;h)*norm_2;
<a name="line400">400: </a>  <A href="../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(appctx-&gt;solution,<A href="../../../../docs/manualpages/Vec/NORM_MAX.html#NORM_MAX">NORM_MAX</A>,&amp;norm_max);

<a name="line402">402: </a>  <A href="../../../../docs/manualpages/TS/TSGetTimeStep.html#TSGetTimeStep">TSGetTimeStep</A>(ts,&amp;dt);
<a name="line403">403: </a>  printf(<font color="#666666">"Timestep %d: step <A href="../../../../docs/manualpages/Sys/size.html#size">size</A> = %G, time = %G, 2-norm error = %G, max norm error = %G\n"</font>,
<a name="line404">404: </a>         (int)step,dt,crtime,norm_2,norm_max);
<a name="line405">405: </a>  appctx-&gt;norm_2   += norm_2;
<a name="line406">406: </a>  appctx-&gt;norm_max += norm_max;

<a name="line408">408: </a>  dttol = .0001;
<a name="line409">409: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-dttol"</font>,&amp;dttol,&amp;flg);
<a name="line410">410: </a>  <font color="#4169E1">if</font> (dt &lt; dttol) {
<a name="line411">411: </a>    dt *= .999;
<a name="line412">412: </a>    <A href="../../../../docs/manualpages/TS/TSSetTimeStep.html#TSSetTimeStep">TSSetTimeStep</A>(ts,dt);
<a name="line413">413: </a>  }

<a name="line415">415: </a>  <font color="#B22222">/* </font>
<a name="line416">416: </a><font color="#B22222">     View a graph of the error</font>
<a name="line417">417: </a><font color="#B22222">  */</font>
<a name="line418">418: </a>  <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(appctx-&gt;solution,appctx-&gt;viewer1);

<a name="line420">420: </a>  <font color="#B22222">/*</font>
<a name="line421">421: </a><font color="#B22222">     Print debugging information if desired</font>
<a name="line422">422: </a><font color="#B22222">  */</font>
<a name="line423">423: </a>  <font color="#4169E1">if</font> (appctx-&gt;debug) {
<a name="line424">424: </a>     printf(<font color="#666666">"Error vector\n"</font>);
<a name="line425">425: </a>     <A href="../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(appctx-&gt;solution,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>);
<a name="line426">426: </a>  }

<a name="line428">428: </a>  <font color="#4169E1">return</font> 0;
<a name="line429">429: </a>}
<a name="line430">430: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line433">433: </a><font color="#B22222">/*</font>
<a name="line434">434: </a><font color="#B22222">   RHSMatrixHeat - User-provided routine to compute the right-hand-side</font>
<a name="line435">435: </a><font color="#B22222">   matrix for the heat equation.</font>

<a name="line437">437: </a><font color="#B22222">   Input Parameters:</font>
<a name="line438">438: </a><font color="#B22222">   ts - the <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> context</font>
<a name="line439">439: </a><font color="#B22222">   t - current time</font>
<a name="line440">440: </a><font color="#B22222">   global_in - global input vector</font>
<a name="line441">441: </a><font color="#B22222">   dummy - optional user-defined context, as set by TSetRHSJacobian()</font>

<a name="line443">443: </a><font color="#B22222">   Output Parameters:</font>
<a name="line444">444: </a><font color="#B22222">   AA - Jacobian matrix</font>
<a name="line445">445: </a><font color="#B22222">   BB - optionally different preconditioning matrix</font>
<a name="line446">446: </a><font color="#B22222">   str - flag indicating matrix structure</font>

<a name="line448">448: </a><font color="#B22222">   Notes:</font>
<a name="line449">449: </a><font color="#B22222">   Recall that <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>() uses 0-based row and column numbers</font>
<a name="line450">450: </a><font color="#B22222">   in Fortran as well as in C.</font>
<a name="line451">451: </a><font color="#B22222">*/</font>
<a name="line452">452: </a><strong><font color="#4169E1"><a name="RHSMatrixHeat"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> RHSMatrixHeat(<A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *AA,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *BB,<A href="../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A> *str,void *ctx)</font></strong>
<a name="line453">453: </a>{
<a name="line454">454: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            A = *AA;                      <font color="#B22222">/* Jacobian matrix */</font>
<a name="line455">455: </a>  AppCtx         *appctx = (AppCtx *) ctx;     <font color="#B22222">/* user-defined application context */</font>
<a name="line456">456: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       mstart = 0;
<a name="line457">457: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       mend = appctx-&gt;m;
<a name="line459">459: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i, idx[3];
<a name="line460">460: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    v[3], stwo = -2./(appctx-&gt;h*appctx-&gt;h), sone = -.5*stwo;

<a name="line462">462: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line463">463: </a><font color="#B22222">     Compute entries for the locally owned part of the matrix</font>
<a name="line464">464: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line465">465: </a>  <font color="#B22222">/* </font>
<a name="line466">466: </a><font color="#B22222">     Set matrix rows corresponding to boundary data</font>
<a name="line467">467: </a><font color="#B22222">  */</font>

<a name="line469">469: </a>  mstart = 0;
<a name="line470">470: </a>  v[0] = 1.0;
<a name="line471">471: </a>  <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,1,&amp;mstart,1,&amp;mstart,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line472">472: </a>  mstart++;

<a name="line474">474: </a>  mend--;
<a name="line475">475: </a>  v[0] = 1.0;
<a name="line476">476: </a>  <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,1,&amp;mend,1,&amp;mend,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);

<a name="line478">478: </a>  <font color="#B22222">/*</font>
<a name="line479">479: </a><font color="#B22222">     Set matrix rows corresponding to interior data.  We construct the </font>
<a name="line480">480: </a><font color="#B22222">     matrix one row at a time.</font>
<a name="line481">481: </a><font color="#B22222">  */</font>
<a name="line482">482: </a>  v[0] = sone; v[1] = stwo; v[2] = sone;
<a name="line483">483: </a>  <font color="#4169E1">for</font> ( i=mstart; i&lt;mend; i++ ) {
<a name="line484">484: </a>    idx[0] = i-1; idx[1] = i; idx[2] = i+1;
<a name="line485">485: </a>    <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,1,&amp;i,3,idx,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line486">486: </a>  }

<a name="line488">488: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line489">489: </a><font color="#B22222">     Complete the matrix assembly process and set some options</font>
<a name="line490">490: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line491">491: </a>  <font color="#B22222">/*</font>
<a name="line492">492: </a><font color="#B22222">     Assemble matrix, using the 2-step process:</font>
<a name="line493">493: </a><font color="#B22222">       <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(), <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>()</font>
<a name="line494">494: </a><font color="#B22222">     Computations can be done while messages are in transition</font>
<a name="line495">495: </a><font color="#B22222">     by placing code between these two statements.</font>
<a name="line496">496: </a><font color="#B22222">  */</font>
<a name="line497">497: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(A,MAT_FINAL_ASSEMBLY);
<a name="line498">498: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(A,MAT_FINAL_ASSEMBLY);

<a name="line500">500: </a>  <font color="#B22222">/*</font>
<a name="line501">501: </a><font color="#B22222">     Set flag to indicate that the Jacobian matrix retains an identical</font>
<a name="line502">502: </a><font color="#B22222">     nonzero structure throughout all timestepping iterations (although the</font>
<a name="line503">503: </a><font color="#B22222">     values of the entries change). Thus, we can save some work in setting</font>
<a name="line504">504: </a><font color="#B22222">     up the preconditioner (e.g., no need to redo symbolic factorization for</font>
<a name="line505">505: </a><font color="#B22222">     ILU/ICC preconditioners).</font>
<a name="line506">506: </a><font color="#B22222">      - If the nonzero structure of the matrix is different during</font>
<a name="line507">507: </a><font color="#B22222">        successive linear solves, then the flag DIFFERENT_NONZERO_PATTERN</font>
<a name="line508">508: </a><font color="#B22222">        must be used instead.  If you are unsure whether the matrix</font>
<a name="line509">509: </a><font color="#B22222">        structure has changed or not, use the flag DIFFERENT_NONZERO_PATTERN.</font>
<a name="line510">510: </a><font color="#B22222">      - Caution:  If you specify SAME_NONZERO_PATTERN, PETSc</font>
<a name="line511">511: </a><font color="#B22222">        believes your assertion and does not check the structure</font>
<a name="line512">512: </a><font color="#B22222">        of the matrix.  If you erroneously claim that the structure</font>
<a name="line513">513: </a><font color="#B22222">        is the same when it actually is not, the new preconditioner</font>
<a name="line514">514: </a><font color="#B22222">        will not function correctly.  Thus, use this optimization</font>
<a name="line515">515: </a><font color="#B22222">        feature with caution!</font>
<a name="line516">516: </a><font color="#B22222">  */</font>
<a name="line517">517: </a>  *str = SAME_NONZERO_PATTERN;

<a name="line519">519: </a>  <font color="#B22222">/*</font>
<a name="line520">520: </a><font color="#B22222">     Set and option to indicate that we will never add a new nonzero location </font>
<a name="line521">521: </a><font color="#B22222">     to the matrix. If we do, it will generate an error.</font>
<a name="line522">522: </a><font color="#B22222">  */</font>
<a name="line523">523: </a>  <A href="../../../../docs/manualpages/Mat/MatSetOption.html#MatSetOption">MatSetOption</A>(A,MAT_NEW_NONZERO_LOCATION_ERR);

<a name="line525">525: </a>  <font color="#4169E1">return</font> 0;
<a name="line526">526: </a>}
<a name="line527">527: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line530">530: </a><font color="#B22222">/*</font>
<a name="line531">531: </a><font color="#B22222">   Input Parameters:</font>
<a name="line532">532: </a><font color="#B22222">   ts - the <A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> context</font>
<a name="line533">533: </a><font color="#B22222">   t - current time</font>
<a name="line534">534: </a><font color="#B22222">   f - function</font>
<a name="line535">535: </a><font color="#B22222">   ctx - optional user-defined context, as set by TSetBCFunction()</font>
<a name="line536">536: </a><font color="#B22222"> */</font>
<a name="line537">537: </a><strong><font color="#4169E1"><a name="MyBCRoutine"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MyBCRoutine(<A href="../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> f,void *ctx)</font></strong>
<a name="line538">538: </a>{
<a name="line539">539: </a>  AppCtx         *appctx = (AppCtx *) ctx;     <font color="#B22222">/* user-defined application context */</font>
<a name="line541">541: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       m = appctx-&gt;m;
<a name="line542">542: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *fa;

<a name="line544">544: </a>  <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(f,&amp;fa);
<a name="line545">545: </a>  fa[0] = 0.0;
<a name="line546">546: </a>  fa[m-1] = 1.0;
<a name="line547">547: </a>  <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(f,&amp;fa);
<a name="line548">548: </a>  printf(<font color="#666666">"t=%g\n"</font>,t);
<a name="line549">549: </a>
<a name="line550">550: </a>  <font color="#4169E1">return</font> 0;
<a name="line551">551: </a>}
</pre>
</body>

</html>
